#ifndef INCLUDED_POLYGON_PACK
#define INCLUDED_POLYGON_PACK

#ifndef INCLUDED_SPU_SPAN
#include "spu_span.h"
#endif

typedef struct VertexPack {
  float x;
  float y;
  float z;
  float tex_x;
  float tex_y;
}VertexPack, *VertexPack_ptr;


typedef struct TrianglePack {
  long *tex_addr, tex_width, tex_height;
  VertexPack ver1;
  VertexPack ver2;
  VertexPack ver3;
} TrianglePack;


typedef struct PolygonPack {
  struct PORIGON_info {
    int size;
    int light_pos[3];
    int light_rgb[3];
  }info;
  //SPANPACKLIST *spl;
  SPUSPANLIST *ssl;
  TrianglePack tri[128];    // Variable length array
} PolygonPack, *PolygonPackPtr;

typedef struct PolygonPackList {
  int size;
  //PolygonPack *list[6];
  PolygonPack *list;
} PolygonPackList;

#endif
